import generator.tasksets as gen

from util.stats import Histogram
from util.io import header, get_arg

def sample_utilization(generate, sample_count, bins):
    h = Histogram(0.0, 1.0, bins)
    tasks = generate(None, sample_count)
    for t in tasks:
        h(t.utilization())
    return h

def sample_all():
    bins         = int(get_arg(1, 18))
    sample_count = int(get_arg(2, 100000))
    for name in gen.DIST:
        generate = gen.DIST[name]
        h = sample_utilization(generate, sample_count, bins)
        print header(" %s " % name, width=201)
        print h.as_ascii_bars(width=200, count_fmt="%5.2f", relative_counts=True)

if __name__ == "__main__":
    sample_all()
