from util import us2ms

def account_for_scheduling_overheads(overheads, tasks, preemptive=True):
    T = tasks
    s   = overheads.sched(T)
    s2  = overheads.sched2(T)
    cxs = overheads.ctxsw(T)
#    print 'E: s:%f    s2:%f    cxs:%f' % (s, s2, cxs)
    preemption_charge  = 0.0
    # scheduling occurs before job execution and after job execution
    preemption_charge += 2 * us2ms(s + s2 + cxs)
    if preemptive:
        # Pay for whoever was preempted by the job.
        # Only one charge, since initial cache warm up is assumed to
        # be part of the worst-case execution cost.
        preemption_charge += us2ms(overheads.cache_affinity_loss(T))

    for t in T:
        t.cost += preemption_charge

    return T

