#!/bin/bash

function die {
    echo "Error: $*"
    echo "$0 <tag name>"
    exit 1
}

# take TAG from command line if present
TAG=$1

# default: figure out if current HEAD is tagged
if [ -z "$TAG" ]
then
    TAG=`git tag --contains HEAD`
fi

if [ -z "$TAG" ]
then
    die "could not determine tag for current HEAD and none was specified."
    exit 1
fi


NAME="schedcat-$TAG"
FILE="$NAME.tar"

echo "Generating archive for tag $TAG..."
git archive -o "$FILE" --prefix "$NAME/" "$TAG" || die "failed to create archive."
gzip "$FILE" || die "failed to compress archive."
